image: docker:latest
services:
- docker:dind

variables:
  DOCKER_DRIVER: overlay
  SPRING_PROFILES_ACTIVE: gitlab-ci
#   TIME: ""
#  BRANCH: ""
#  REC_BUILD_NAME: ""

stages:
- build
- package
- deploy
- manual_rec_build
- manual_rec_package

.job_rec_build_template: &job_rec_build_template
  script:
  - "mvn package -B"


.job_rec_build_package_template: &job_rec_build_package_template
  <<: *job_rec_build_template
  script:
  - docker build -t registry.gitlab.com/mourad.sellam/actuator-simple .
  - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
  - docker push registry.gitlab.com/mourad.sellam/actuator-simple


maven-build:
  image: maven:3-jdk-8
  stage: build
  script:
  - "mvn package -B"
  artifacts:
    paths:
    - target/*.jar
  only:
  - merge-requests
  - /^feature\/sprint.*$/
  - /^DEV_.*$/
  when: manual


docker-build:
  stage: package
  script:
  - docker build -t registry.gitlab.com/mourad.sellam/actuator-simple .
  - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
  - docker push registry.gitlab.com/mourad.sellam/actuator-simple
  only:
  - merge-requests
  - /^feature\/sprint.*$/
  - /^DEV_.*$/
  when: manual

k8s-deploy-production:
  image: google/cloud-sdk
  stage: deploy
  script:
  - echo "$GOOGLE_KEY" > key.json
  - gcloud auth activate-service-account --key-file key.json
  - gcloud config set compute/zone europe-west1-c
  - gcloud config set project actuator-sample
  - gcloud config set container/use_client_certificate True
  - gcloud container clusters get-credentials actuator-example
  - kubectl delete secret registry.gitlab.com
  - kubectl create secret docker-registry registry.gitlab.com --docker-server=https://registry.gitlab.com --docker-username=mourad.sellam --docker-password=$REGISTRY_PASSWD --docker-email=mouradsellamg@gmail.com
  - kubectl apply -f deployment.yml --namespace=production
  environment:
    name: production
    url: https://example.production.com
  when: manual



job_manual_rec_build:
  image: maven:3-jdk-8
  stage: manual_rec_build
  script:
  - "mvn package -B"
  artifacts:
    paths:
    - target/*.jar
  when: manual
  allow_failure: false

job_manual_rec_package:
  stage: manual_rec_package
  variables:
  #    20181018hhmm
  #    $(git show -s --format=%ct $CI_COMMIT_SHA)
  #    $(git show -s --format=%cd $CI_COMMIT_SHA)
  #    $(git --date=iso --pretty=format:'%Y%m%d%H%M')
  #    $(git show --quiet --date='format-local:%Y%m%d%H%M' --format="%cd")
  #    TIME:  $(git show --quiet --date='format-local:%Y%m%d%H%M' --format="%cd")
  #    REC_TAG_NAME: REC_GARI_${TIME}
  #    date +%Y%m%d%H%M
  script:
  #  - let $TIME="20181018"
  #  - let $BRANCH="sprint1"
  #$(echo $CI_BUILD_REF_SLUG | sed 's/[^[[:alnum:]]//g')
  # echo feature/sprint1  | sed 's/[^[[:alnum:]]//g'
  - "TIME=$(date +%Y%m%d%H%M)"
  - "BRANCH=$(echo $CI_BUILD_REF_SLUG | sed 's/[^[[:alnum:]]/_/g')"
  - "DEV_BUILD_NAME=REC_GARI_${BRANCH}_${TIME}"
  - docker build -t registry.gitlab.com/mourad.sellam/actuator-simple:${DEV_BUILD_NAME} .
  - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
  - docker push registry.gitlab.com/mourad.sellam/actuator-simple
  artifacts:
    paths:
    - target/*.jar
  when: on_success